﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace NLScC.Command
{
    class RelayCommand : ICommand
    {
        private Action<object> _execute;
        private Predicate<object> _canExecute;
        private ICommand selectGroup;
        private object selectGroupCanExecute;

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value; }
            remove { CommandManager.RequerySuggested -= value; }
        }

        public RelayCommand(Action<object> execute,Predicate<object> canExecute = null)
        {
            if (execute == null) throw new ArgumentNullException("Execute cannot be null");
            this._execute = execute;
            this._canExecute = canExecute;
        }

        public RelayCommand(ICommand selectGroup, object selectGroupCanExecute)
        {
            this.selectGroup = selectGroup;
            this.selectGroupCanExecute = selectGroupCanExecute;
        }

        public bool CanExecute(object parameter)
        {
            return this._canExecute == null || this._canExecute(parameter);
        }

        public void Execute(object parameter)
        {
            this._execute(parameter);
        }
    }
}
