﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using NLScC.Command;
using NLScC.model;

namespace NLScC
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {


        private void ResetLogLevel()
        {
            LogConsole.Logger.ResetLogLevel();
        }

        public static MainWindow AppReference;
        public static Dictionary<string, string> WebDictionary;


  
        private void CheckForCommandParameter()
        {
            string[] cmdLines = Environment.CommandLine.Split();
            if (cmdLines.Length == 1) return;
            for (int i = 1; i < cmdLines.Length; i++)
            {
                if (cmdLines[i] == "WindowsAutostartTrue")
                {
                    if (!AppSettings.Settings.IsStartetWithWindows) this.Close();
                }
            }
        }

        public MainWindow()
        {



            StartUpChecker.CheckStartUpFiles();
            WebDictionary = new Dictionary<string, string>();

            InitializeComponent();
            InitializeCommands();

            OverrideAppSettings();
            CheckForCommandParameter();
            this.Height = AppSettings.Settings.AppHeight;
            this.Width = AppSettings.Settings.AppWidth;
            this.Top = AppSettings.Settings.AppTop;
            this.Left = AppSettings.Settings.AppLeft;

            AppReference = this;

            //NLScC.ViewModel.AutostartViewModel asvm = this.FindResource("ViewAutostart") as NLScC.ViewModel.AutostartViewModel;
            //asvm?.WriteFileToDisk();
        }


        public void OverrideAppSettings()
        {
            var s = FindResource("AppSettings");
            Console.WriteLine(s.GetType());
            AppSettings.LoadExistingConfig((AppSettings)s);
        }

        #region Commands
       


        private void InitializeCommands()
        {
            
        }

        #endregion


        #region
        private void DragAndMoveWindow(object sender, MouseButtonEventArgs e)
        {
            if(e.ChangedButton == MouseButton.Left)
            {
                this.DragMove();
            }
        }

        #endregion


        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            //AppSettings.Settings.SaveConfigToDisk();
            //NLScC.ViewModel.ProgramManagerViewModel pmvm = this.FindResource("ViewProgramManager") as NLScC.ViewModel.ProgramManagerViewModel;
            //pmvm?.WriteFilesToDisk();
            //NLScC.ViewModel.AutostartViewModel asvm = this.FindResource("ViewAutostart") as NLScC.ViewModel.AutostartViewModel;
            //asvm?.WriteFileToDisk();
            //NLScC.ViewModel.MemberViewModel nlsvm = this.FindResource("ViewNLSMembers") as NLScC.ViewModel.MemberViewModel;
            //nlsvm?.WriteFileTodisk();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            AppSettings.Settings.ManagedAppWidth = 8;
            AppSettings.Settings.ManagedAppHeight = 8;
        }

        private void Window_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            LogConsole.Logger.Document.PageWidth = this.ActualWidth - 100;
        }

        private void Image_MouseDown(object sender, MouseButtonEventArgs e)
        {
            ResetLogLevel();
        }

    }
}
