﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using NLScC.model;
using System.Windows.Input;
using NLScC.Command;

namespace NLScC.ViewModel
{
    class CustomViewModel : NotifyBase
    {

        public ICommand NewEntryCommand { get; internal set; }
        public ICommand DeleteEntryCommand { get; internal set; }
        public ICommand ApplyChangesCommand { get; internal set; }


        private void InitializeCommands()
        {
            NewEntryCommand = new RelayCommand(NewEntryExecute);
            DeleteEntryCommand = new RelayCommand(DeleteEntryExecute, DeleteEntryCanExecute);
        }

        private bool DeleteEntryCanExecute(object obj)
        {
            return _customs.Count > 0;
        }

        private void DeleteEntryExecute(object obj)
        {
            _customView.Remove(_customView.CurrentItem);
        }

        private void NewEntryExecute(object obj)
        {
            _customs.Add(new NLSMember("Mustermann", "Max", "00000", "max.mustermann@mustermail.com"));
        }

        private string _filePath = AppSettings.DataPath + @"\customs.nlscco";
        private NLSMemberCollection _customs;
        private ListCollectionView _customView;
        public ListCollectionView CustomView
        {
            get { return _customView; }
        }
        public NLSMemberCollection CustomList
        {
            get { return _customs; }
        }

        public CustomViewModel()
        {
            _customs = new NLSMemberCollection();
            _customView = new ListCollectionView(_customs);
            InitializeCommands();
        }

        public void CopyOriginalData(NLSMemberCollection originalCollection)
        {
            foreach (NLSMember nls in originalCollection)
            {
                if(nls.Unit == NLSUnit.Custom)_customs.Add(nls);
            }
        }
    }
}
