﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using NLScC.model;

namespace NLScC.converter
{
    class ImageSourceConverter : IMultiValueConverter, IValueConverter
    {

        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            string path = (string)values[0];
            ApplicationType type = (ApplicationType)values[1];

            if (type == ApplicationType.Application)
            {
                if (IsPicture(path)) return new BitmapImage(new Uri(path));
                try
                {
                    Icon icon = System.Drawing.Icon.ExtractAssociatedIcon((string)path);
                    ImageSource imageSource = Imaging.CreateBitmapSourceFromHIcon(
                        icon.Handle,
                        Int32Rect.Empty,
                        BitmapSizeOptions.FromEmptyOptions());
                    return imageSource;
                }
                catch (System.IO.FileNotFoundException)
                {
                    return new BitmapImage(new Uri("pack://application:,,,/images/other/404.png"));
                }
            }
            else if (type == ApplicationType.Folder)
            {
                return new BitmapImage(new Uri("pack://application:,,,/images/programmanager/foldermanager.png"));
            }
            else if (type == ApplicationType.Chrome || type == ApplicationType.Edge || type == ApplicationType.Firefox || type == ApplicationType.Website)
            {
                try
                {
                    return new BitmapImage(new Uri(path));
                }
                catch(Exception)
                {
                    return new BitmapImage(new Uri("pack://application:,,,/images/other/404.png"));
                }
            }
            else
            {
                return new BitmapImage(new Uri("pack://application:,,,/images/other/404.png"));
            }
        }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {

           if (value != null) return new BitmapImage(new Uri((string)value, UriKind.RelativeOrAbsolute));
            return new BitmapImage();
            //ApplicationType type = (ApplicationType)value;
            //switch (type)
            //{
            //    case ApplicationType.Chrome:
            //        return new BitmapImage(new Uri("pack://application:,,,/images/web/chrome.png"));
            //    case ApplicationType.Firefox:
            //        return new BitmapImage(new Uri("pack://application:,,,/images/web/firefox.png"));
            //    case ApplicationType.Edge:
            //        return new BitmapImage(new Uri("pack://application:,,,/images/web/edge.png"));
            //    case ApplicationType.Website:
            //        return new BitmapImage(new Uri("pack://application:,,,/images/web/web.png"));
            //}
            //return new BitmapImage(new Uri("pack://application:,,,/images/other/404.png"));
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        private bool IsPicture(string path)
        {
            var s = System.IO.Path.GetExtension(path);
            return s == ".png" || s == ".jpg" || s == ".gif" || s == "bmp";
        }
    }
}
