﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace NLScC.dialog
{
    /// <summary>
    /// Interaktionslogik für AddFolderDialog.xaml
    /// </summary>
    public partial class AddFolderDialog : Window
    {
        public AddFolderDialog()
        {
            InitializeComponent();
        }

        public AddFolderDialog(bool useGroupBox, List<string> groupList) : this()
        {
            if (useGroupBox)
            {
                GroupBox.Visibility = Visibility.Visible;
                GroupInsert.Visibility = Visibility.Visible;
                GroupInsertText.Visibility = Visibility.Visible;
                for (int i = 0; i< groupList.Count; i++)
                {
                    GroupBox.Items.Add(groupList.ElementAt(i));
                }
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.FolderBrowserDialog dialog = new System.Windows.Forms.FolderBrowserDialog();
            if(dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                FolderPath.Text = dialog.SelectedPath;
            }
        }

        private void OK_Click(object sender, RoutedEventArgs e)
        {
            if(!string.IsNullOrEmpty(FolderName.Text) && !string.IsNullOrEmpty(FolderPath.Text))
            {
                this.DialogResult = true;
            }
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }
    }
}
