﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace NLScC.dialog
{
    /// <summary>
    /// Interaktionslogik für CustomDialog.xaml
    /// </summary>
    public partial class CustomDialog : Window
    {
        internal NLScC.model.NLSMemberCollection Collection { get; private set; }

        public CustomDialog()
        {
            InitializeComponent();
        }

        internal CustomDialog(NLScC.model.NLSMemberCollection collection) :this()
        {
            NLScC.ViewModel.CustomViewModel viewmodel = this.FindResource("ViewCustoms") as NLScC.ViewModel.CustomViewModel;
            viewmodel?.CopyOriginalData(collection);
        }

        private void Closes_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }

        private void ApplyAndClose_Click(object sender, RoutedEventArgs e)
        {
            NLScC.ViewModel.CustomViewModel viewmodel = this.FindResource("ViewCustoms") as NLScC.ViewModel.CustomViewModel;
            Collection = viewmodel.CustomList;
            this.DialogResult = true;
        }

        private void TextBox_GotFocus(object sender, RoutedEventArgs e)
        {
            var s = sender as TextBox;
            s.SelectAll();
        }

        private void TextBox_MouseDown(object sender, MouseButtonEventArgs e)
        {
            TextBox_GotFocus(sender, e);
        }
    }
}
