﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Markup;

namespace NLScC.model
{
    public enum NLSUnit
    {
        Meldestelle,
        Gasdispatching,
        GasBackoffice,
        Mittelspannung,
        Hochspannung,
        StromBackoffice,
        Supervisor,
        Custom
    }

    public class NLSUnitClass : MarkupExtension
    {
        private readonly Type _type;

        public NLSUnitClass(Type type)
        {
            _type = type;
        }

        public override object ProvideValue(IServiceProvider serviceProvider)
        {
            return Enum.GetValues(_type);
        }

    }

    public class NLSMember : NotifyBase
    {
        private string _lastname;
        public string Lastname
        {
            get { return _lastname; }
            set { SetField(ref _lastname, value); }
        }

        private string _prename;
        public string Prename
        {
            get { return _prename; }
            set { SetField(ref _prename, value); }
        }

        private string _callingNumber;
        public string CallingNumber
        {
            get { return _callingNumber; }
            set { SetField(ref _callingNumber, value); }
        }

        private string _mail;
        public string Mail
        {
            get { return _mail; }
            set { SetField(ref _mail, value); }
        }

        private NLSUnit _unit;
        public NLSUnit Unit
        {
            get { return _unit; }
            set { SetField(ref _unit, value); }
        }

        public NLSMember()
        {

        }

        public NLSMember(string lastname, string prename, string callinnumber, string mail, NLSUnit unit = NLSUnit.Custom)
        {
            this._lastname = lastname;
            this._prename = prename;
            this._callingNumber = callinnumber;
            this._mail = mail;
            this._unit = unit;
        }
    }
}
